/* 
 This file was generated by Dashcode.  
 You may edit this file to customize your widget or web page 
 according to the license.txt file included in the project.
 */

var logs = [
    ['System log', '/var/log/system.log'],
    ['Apache 2 access', '/var/log/apache2/access_log'],
    ['Apache 2 errors', '/var/log/apache2/error_log'],
    ['Security log', '/var/log/secure.log'],
    ['Installer log', '/varlog/install.log'],
    ['Custom...', 'custom']
];

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
// newsyslog!!!
//
function load()
{
    dashcode.setupParts();
    dashLogInit ();
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    // populate hosts menu
    var host = widget.preferenceForKey ('host');
    var hp = document.getElementById ('hostPopup').object;
    var opts = []; var selIdx = 0;
    var awk = widget.system ('/usr/bin/awk \'/host / {print $2}\' $HOME/.ssh/config', null);
    var hosts = awk.outputString.split ('\n');
    
    for (var i = 0; i < (hosts.length - 1); i++) {
        var h = hosts[i];
        opts.push([hosts[i], hosts[i]]);
        if (h == host) selIdx = i;
    }
    
    hp.setOptions (opts);
    hp.setSelectedIndex (selIdx);
    
    // populate log menu
    var log = widget.preferenceForKey ('log');
    var lp = document.getElementById ('logPopup').object;
    selIdx = 0;
    
    for (var i = 0; i < logs.length; i++) {
        if (logs[i][1] == log) selIdx = i;
    }
    
    lp.setOptions (logs);
    lp.setSelectedIndex (selIdx);
    
    document.getElementById ('customLog').value = widget.preferenceForKey ('customLog');
    
    var front = document.getElementById ("front");
    var back = document.getElementById ("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var cl = document.getElementById ('customLog');
    var hp = document.getElementById ('hostPopup');
    var lp = document.getElementById ('logPopup');
    
    widget.setPreferenceForKey (cl.value, 'customLog');
    widget.setPreferenceForKey (lp.object.getValue(), 'log');
    widget.setPreferenceForKey (hp.object.getValue(), 'host');
    
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
    
    dashLogInit ();
    
}

function dashLogInit ()
{
    var log = widget.preferenceForKey ('log');
    var host = widget.preferenceForKey ('host');
    if (log == 'custom') log = widget.preferenceForKey ('customLog');
    
    if (!host || !log) return showBack ();
    
    var sa = document.getElementById ('scrollArea');
    sa.object.content.innerHTML = '';
    
    endHandler = function (c) {
        c.cancel ();
        sa.object.content.innerHTML = '<div id="error">There was an error reading the log file</div>';
    }
    
    outHandler = function (o) {
        sa.object.content.innerHTML += o;
        sa.object.refresh ();
    }
    
    var cmd = widget.system ('/usr/bin/ssh ' + host + ' /usr/bin/tail -f ' + log, endHandler);
    cmd.onreadoutput = outHandler;
    
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
}

function logPopupChanged(event)
{   
    var el = document.getElementById ('customLog');
    el.style.visibility = (event.target.value == 'custom') ? 'visible' : 'hidden';
    if (el.style.visibility == 'visible')
        el.focus ();
}
